unit synform;
(*Object Pascal lacks any macro capability for repetitive syntax
  writing.  Having to type "if  then  else" or "begin end" sequences
  is so boring that this form can be integrated into the IDE Tools
  so that you can select a particular syntax to be cut to the clipboard
  and then pasted to the location of the cursor in your source code.
  Each time the tool is used, it is minimized so you can call it
  again and again.
  Author:  Charles M. Fisher
  Date:    1 November 1996  *)

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    InstrLabel:    TLabel;
    RadioButton1:  TRadioButton;
    RadioButton2:  TRadioButton;
    RadioButton3:  TRadioButton;
    RadioButton4:  TRadioButton;
    RadioButton5:  TRadioButton;
    RadioButton6:  TRadioButton;
    RadioButton7:  TRadioButton;
    RadioButton8:  TRadioButton;
    RadioButton9:  TRadioButton;
    RadioButton10: TRadioButton;
    RadioButton11: TRadioButton;
    RadioButton12: TRadioButton;
    RadioButton13: TRadioButton;
    Memo1: TMemo;
    RadioButton14: TRadioButton;
    Label1: TLabel;
    procedure RadioButton1Click(Sender: TObject);
    procedure RadioButton2Click(Sender: TObject);
    procedure RadioButton3Click(Sender: TObject);
    procedure RadioButton4Click(Sender: TObject);
    procedure RadioButton5Click(Sender: TObject);
    procedure RadioButton6Click(Sender: TObject);
    procedure RadioButton7Click(Sender: TObject);
    procedure RadioButton8Click(Sender: TObject);
    procedure RadioButton9Click(Sender: TObject);
    procedure RadioButton10Click(Sender: TObject);
    procedure RadioButton11Click(Sender: TObject);
    procedure RadioButton12Click(Sender: TObject);
    procedure RadioButton13Click(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure RadioButton14Click(Sender: TObject);
    procedure FormDblClick(Sender: TObject);
  private
    { Private declarations }
    FWnd: HWnd;
  public
    { Public declarations }
    procedure PasteToSource;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormDblClick(Sender: TObject);
begin
  Application.HelpContext(0);
end;

procedure TForm1.PasteToSource;
begin
  {Find Delphi }
  FWnd := FindWindow('TAppBuilder', nil);
  if FWnd = 0 then
    begin
      showMessage('Cannot find TAppBuilder');
      exit;
    end;
  if IsIconic(FWnd) then
    SendMessage(wm_SysCommand, sc_Restore, 0,0)
  else
    BringWindowToTop(FWnd);
  { Force pasting clipboard contents with Alt 'E' 'P' from delphi.}
  keybd_event(vk_Menu, 0, 0, 0);                { Press the Alt key }
  keybd_event(vk_Menu, 0, KEYEVENTF_KEYUP, 0);  { Release it }
  keybd_event(ord('E'), 0, 0, 0);
  keybd_event(ord('E'), 0, KEYEVENTF_KEYUP, 0);
  keybd_event(ord('P'), 0, 0, 0);
  keybd_event(ord('P'), 0, KEYEVENTF_KEYUP, 0);
end;

procedure TForm1.RadioButton1Click(Sender: TObject);
begin
  Memo1.Lines[0] := ('begin');
  Memo1.Lines.Add(' ');
  Memo1.Lines.Add('end;');
  Memo1.SelectAll;
  Memo1.CopyToClipboard;
  PasteToSource;
  WindowState := wsMinimized;
end;

procedure TForm1.RadioButton2Click(Sender: TObject);
begin
  Memo1.Lines[0] := ('if    then');
  Memo1.SelectAll;
  Memo1.CopyToClipboard;
  PasteToSource;
  WindowState := wsMinimized;
end;

procedure TForm1.RadioButton3Click(Sender: TObject);
begin
  Memo1.Lines[0] := ('if    then');
  Memo1.Lines.Add('  begin');
  Memo1.Lines.Add(' ');
  Memo1.Lines.Add('  end;');
  Memo1.SelectAll;
  Memo1.CopyToClipboard;
  PasteToSource;
  WindowState := wsMinimized;
end;

procedure TForm1.RadioButton4Click(Sender: TObject);
begin
  Memo1.Lines[0] := ('while  do');
  Memo1.SelectAll;
  Memo1.CopyToClipboard;
  PasteToSource;
  WindowState := wsMinimized;
end;

procedure TForm1.RadioButton5Click(Sender: TObject);
begin
  Memo1.Lines[0] := ('while    do');
  Memo1.Lines.Add('  begin');
  Memo1.Lines.Add(' ');
  Memo1.Lines.Add('  end;');
  Memo1.SelectAll;
  Memo1.CopyToClipboard;
  PasteToSource;
  WindowState := wsMinimized;
end;

procedure TForm1.RadioButton6Click(Sender: TObject);
begin
  Memo1.Lines[0] := ('for i := 0 to MAX do');
  Memo1.SelectAll;
  Memo1.CopyToClipboard;
  PasteToSource;
  WindowState := wsMinimized;
end;

procedure TForm1.RadioButton7Click(Sender: TObject);
begin
  Memo1.Lines[0] := ('for i := 0 to MAX do');
  Memo1.Lines.Add('  begin');
  Memo1.Lines.Add(' ');
  Memo1.Lines.Add('  end;');
  Memo1.SelectAll;
  Memo1.CopyToClipboard;
  PasteToSource;
  WindowState := wsMinimized;
end;

procedure TForm1.RadioButton8Click(Sender: TObject);
begin
  Memo1.Lines[0] := ('try');
  Memo1.Lines.Add(' ');
  Memo1.Lines.Add('except');
  Memo1.Lines.Add(' ');
  Memo1.Lines.Add('end;');
  Memo1.SelectAll;
  Memo1.CopyToClipboard;
  PasteToSource;
  WindowState := wsMinimized;
end;

procedure TForm1.RadioButton9Click(Sender: TObject);
begin
  Memo1.Lines[0] := ('try');
  Memo1.Lines.Add(' ');
  Memo1.Lines.Add('finally');
  Memo1.Lines.Add(' ');
  Memo1.Lines.Add('end;');
  Memo1.SelectAll;
  Memo1.CopyToClipboard;
  PasteToSource;
  WindowState := wsMinimized;
end;

procedure TForm1.RadioButton10Click(Sender: TObject);
begin
  Memo1.Lines[0] := ('try');
  Memo1.Lines.Add(' ');
  Memo1.Lines.Add('  try');
  Memo1.Lines.Add(' ');
  Memo1.Lines.Add('  except');
  Memo1.Lines.Add(' ');
  Memo1.Lines.Add('  end;');
  Memo1.Lines.Add('finally');
  Memo1.Lines.Add(' ');
  Memo1.Lines.Add('end;');
  Memo1.SelectAll;
  Memo1.CopyToClipboard;
  PasteToSource;
  WindowState := wsMinimized;
end;

procedure TForm1.RadioButton11Click(Sender: TObject);
begin
  Memo1.Lines[0] := ('{ }');
  Memo1.SelectAll;
  Memo1.CopyToClipboard;
  PasteToSource;
  WindowState := wsMinimized;
end;

procedure TForm1.RadioButton12Click(Sender: TObject);
begin
  Memo1.Lines[0] := ('(*  *)');
  Memo1.SelectAll;
  Memo1.CopyToClipboard;
  PasteToSource;
  WindowState := wsMinimized;
end;

procedure TForm1.RadioButton13Click(Sender: TObject);
begin
  Memo1.Lines[0] := ('if    then');
  Memo1.Lines.Add('  begin');
  Memo1.Lines.Add(' ');
  Memo1.Lines.Add('  end');
  Memo1.Lines.Add('else');
  Memo1.Lines.Add('  begin');
  Memo1.Lines.Add(' ');
  Memo1.Lines.Add('  end;');
  Memo1.SelectAll;
  Memo1.CopyToClipboard;
  PasteToSource;
  WindowState := wsMinimized;
end;

procedure TForm1.RadioButton14Click(Sender: TObject);
begin
  Memo1.Lines[0] := ('case  of');
  Memo1.Lines.Add('  :');
  Memo1.Lines.Add(' ');
  Memo1.Lines.Add('  :');
  Memo1.Lines.Add('else');
  Memo1.Lines.Add('  :');
  Memo1.Lines.Add('end;');
  Memo1.SelectAll;
  Memo1.CopyToClipboard;
  PasteToSource;
  WindowState := wsMinimized;
end;

procedure TForm1.FormPaint(Sender: TObject);
var
  i : integer;
begin
  { Remove checks and clear the invisible Memo. }
  for i := 0 to ComponentCount-1 do
    if Components[i] is TRadioButton then
      TRadioButton(Components[i]).checked := false
    else
      Memo1.Clear;
end;

end.
